# $Id: sudosh2.spec 178 2013-04-28 11:49:23Z u09422fra $
#
%define pkgn    sudosh2
%define pkgv    1.0.4
#
Summary: Logged root shell that can be used for auditing
Name: %{pkgn}
Version: %{pkgv}
Release: 1
Group: System Environment/Base
Source0: %{name}-%{version}.tar.gz
Patch0: %{name}.patch
URL: http://sourceforge.net/projects/sudosh2/
License: OSL
BuildRoot: %{buildroot}
BuildRequires: make
AutoReqProv: no

%description
sudosh2 works directly with sudo to provide a fully functional shell that
users may use to obtain full root access. Unlike providing a team of system
administrators full root access through sudo, it guarantees that detailed
logs are kept. It uses the script command in conjunction with a secure FIFO
and comes with a utility to view sessions and drill down deeper and see the
actual session output.

%prep
%setup -q
%patch0

CONFIG_SHELL=/opt/freeware/bin/bash; export CONFIG_SHELL
CONFIG_ENV_ARGS=/opt/freeware/bin/bash; export CONFIG_ENV_ARGS

CC=cc; export CC
CFLAGS="-qmaxmem=16384 -DSYSV -D_AIX -D_AIX32 -D_AIX41 -D_AIX43 -D_AIX51 -D_AIX52 -D_AIX53 -D_AIX61 -D_ALL_SOURCE -DFUNCPROTO=15 -I/opt/freeware/include"; export CFLAGS
CXX=xlC; export CXX
CXXFLAGS=$CFLAGS; export CXXFLAGS
LD=ld; export LD
LDFLAGS="-L/opt/freeware/lib/%{name} -L/opt/freeware/lib -Wl,-bmaxdata:0x80000000 ${LDFLAGS}"; export LDFLAGS

./configure \
    --prefix=%{_prefix} \
    --sysconfdir=%{_sysconfdir}/%{name} \
    --libdir=%{_libdir}/%{name} \
    --mandir=%{_mandir} \
    --localstatedir=%{_var}/%{name} \
    --with-logdir=%{_var}/%{name}

%{__cat} <<EOF >sudosh.conf.tmp
# Sudosh Configuration File
logdir                  = %{_var}/%{name}
default shell           = /usr/bin/bash
delimiter               = -
syslog.priority         = LOG_NOTICE
syslog.facility         = LOG_DAEMON

# Allow Sudosh to execute -c arguements?  If so, what?
-c arg allow = scp
-c arg allow = sftp
-c arg allow = /usr/sbin/sftp-server
# -c arg allow = rsync
EOF

%build
gmake

%install
[ -d %{buildroot} ] && [ "%{buildroot}" != "/" ] && rm -rf %{buildroot} && mkdir -p %{buildroot}
gmake DESTDIR=%{buildroot} install
/opt/freeware/bin/install -p -m 644 sudosh.conf.tmp %{buildroot}%{_sysconfdir}/%{name}/sudosh.conf
mkdir -p %{buildroot}/%{_var}/%{name}

# Strip binaries
set +x
find %{buildroot}/ -type f | while read FL; do
    RL="`file ${FL} | grep 'not stripped' 2>/dev/null || :`"
    if [ "${RL}" != "" ]; then
        strip ${FL}
    fi
done
set -x

%clean
MRM=`pwd` ;
cd .. ;
MWD=`pwd` ;
[ "${MWD}" != "${RPM_BUILD_DIR}" ] && MRM='' ;
rm -rf "${MRM}" "%{buildroot}"

%pre
# Add sudosh to list of login shells
/usr/bin/lssec -f /etc/security/login.cfg -s usw -a shells | /usr/bin/grep "%{_bindir}/sudosh" > /dev/null
RC=$?
if [ "${RC}" != "0" ]; then
    SHVAL="`/usr/bin/lssec -f /etc/security/login.cfg -s usw -a shells | /usr/bin/cut -d '=' -f2`"
    /usr/bin/chsec -f /etc/security/login.cfg -s usw -a shells="${SHVAL},%{_bindir}/sudosh"
fi
/usr/bin/grep "sudosh" /etc/shells > /dev/null
RC=$?
if [ "${RC}" != "0" ]; then
    echo "/opt/freeware/bin/sudosh" >> /etc/shells
fi

%files
%defattr(-,root,system)
%doc AUTHORS ChangeLog COPYING INSTALL NEWS README PLATFORMS TODO
%attr(0755,root,system)               %dir %{_sysconfdir}/%{name}
%attr(0644,root,system) %config(noreplace) %{_sysconfdir}/%{name}/sudosh.conf
%attr(0733,root,system)               %dir /var/opt/freeware/%{name}
%attr(0644,root,system) %{_mandir}/man1/sudosh.1*
%attr(0644,root,system) %{_mandir}/man5/sudosh.conf.5*
%attr(0644,root,system) %{_mandir}/man8/sudosh-replay.8*
%attr(0755,root,system) %{_bindir}/sudosh
%attr(0755,root,system) %{_bindir}/sudosh-replay

%changelog
* Sun Apr 28 2013 Frank Fegert <fra.nospam.nk@gmx.de> 1.0.4-1 
- Initial build.
